## epics-base 7.0.9

=== documentation/Makefile ===
TOP = ..
include $(TOP)/configure/CONFIG

EXPAND = Doxyfile@
EXPAND_ME += EPICS_VERSION
EXPAND_ME += EPICS_REVISION
EXPAND_ME += EPICS_MODIFICATION
EXPAND_ME += EPICS_PATCH_LEVEL
EXPAND_ME += OS_CLASS CMPLR_CLASS
EXPAND_ME += RTD_SRC

DOXYGEN ?= doxygen

libcom_HEADERS += adjustment
libcom_HEADERS += alarm
libcom_HEADERS += alarmString
libcom_HEADERS += asTrapWrite
libcom_HEADERS += bucketLib
libcom_HEADERS += cantProceed
libcom_HEADERS += compilerDependencies
libcom_HEADERS += cvtFast
libcom_HEADERS += dbmf
libcom_HEADERS += devLibVME
libcom_HEADERS += devLibVMEImpl
libcom_HEADERS += ellLib
libcom_HEADERS += envDefs
libcom_HEADERS += epicsAlgorithm
libcom_HEADERS += epicsAssert
libcom_HEADERS += epicsAtomic
libcom_HEADERS += epicsEvent
libcom_HEADERS += epicsExit
libcom_HEADERS += epicsExport
libcom_HEADERS += epicsGeneralTime
libcom_HEADERS += epicsGuard
libcom_HEADERS += epicsMessageQueue
libcom_HEADERS += epicsMutex
libcom_HEADERS += epicsReadline
libcom_HEADERS += epicsRingBytes
libcom_HEADERS += epicsRingPointer
libcom_HEADERS += epicsSignal
libcom_HEADERS += epicsSpin
libcom_HEADERS += epicsStackTrace
libcom_HEADERS += epicsStdio
libcom_HEADERS += epicsStdlib
libcom_HEADERS += epicsString
libcom_HEADERS += epicsTempFile
libcom_HEADERS += epicsThread
libcom_HEADERS += epicsTime
libcom_HEADERS += epicsTypes
libcom_HEADERS += epicsUnitTest
libcom_HEADERS += errlog
libcom_HEADERS += freeList
libcom_HEADERS += iocsh
libcom_HEADERS += ipAddrToAsciiAsynchronous
libcom_HEADERS += logClient
libcom_HEADERS += macLib
libcom_HEADERS += osiPoolStatus
libcom_HEADERS += osiProcess
libcom_HEADERS += osiSock
libcom_HEADERS += postfix
libcom_HEADERS += shareLib
libcom_HEADERS += testMain
libcom_HEADERS += yajl_alloc
libcom_HEADERS += yajl_common
libcom_HEADERS += yajl_gen
libcom_HEADERS += yajl_parse

database_HEADERS += chfPlugin
database_HEADERS += dbChannel
database_HEADERS += dbCommon
database_HEADERS += dbDefs
database_HEADERS += dbExtractArray
database_HEADERS += dbLink
database_HEADERS += dbServer
database_HEADERS += dbState
database_HEADERS += dbStaticLib
database_HEADERS += dbUnitTest
database_HEADERS += devLib
database_HEADERS += devSup
database_HEADERS += drvSup
database_HEADERS += initHooks

record_HEADERS += aaiRecord
record_HEADERS += aaoRecord
record_HEADERS += aiRecord
record_HEADERS += aoRecord
record_HEADERS += aSubRecord
record_HEADERS += biRecord
record_HEADERS += boRecord
record_HEADERS += calcRecord
record_HEADERS += calcoutRecord
record_HEADERS += compressRecord
record_HEADERS += dfanoutRecord
record_HEADERS += eventRecord
record_HEADERS += fanoutRecord
record_HEADERS += histogramRecord
record_HEADERS += int64inRecord
record_HEADERS += int64outRecord
record_HEADERS += longinRecord
record_HEADERS += longoutRecord
record_HEADERS += lsiRecord
record_HEADERS += lsoRecord
record_HEADERS += mbbiRecord
record_HEADERS += mbbiDirectRecord
record_HEADERS += mbboRecord
record_HEADERS += mbboDirectRecord
record_HEADERS += permissiveRecord
record_HEADERS += printfRecord
record_HEADERS += selRecord
record_HEADERS += seqRecord
record_HEADERS += stateRecord
record_HEADERS += stringinRecord
record_HEADERS += stringoutRecord
record_HEADERS += subRecord
record_HEADERS += subArrayRecord
record_HEADERS += waveformRecord

menu_HEADERS += menuAlarmSevr
menu_HEADERS += menuAlarmStat
menu_HEADERS += menuConvert
menu_HEADERS += menuFtype
menu_HEADERS += menuIvoa
menu_HEADERS += menuOmsl
menu_HEADERS += menuPini
menu_HEADERS += menuPost
menu_HEADERS += menuPriority
menu_HEADERS += menuScan
menu_HEADERS += menuSimm
menu_HEADERS += menuYesNo

HEADER_TYPES = libcom database record menu

HEADER_MD_FILES = $(foreach t, $(HEADER_TYPES), \
    $(addsuffix _h.md, $($t_HEADERS)))
API_RST_FILES = $(addsuffix -api.rst, $(HEADER_TYPES))

RTD_SRC = $(COMMON_DIR)/rtd-src

DOCS += README.md
DOCS += RELEASE_NOTES.md

include $(TOP)/configure/RULES

$(HEADER_MD_FILES): %_h.md: ../HEADER_h.md
	$(EXPAND_TOOL) -t $(INSTALL_LOCATION) -DHEADER=$* $< $@

$(API_RST_FILES): %-api.rst: ../%-API.rst
	@$(RM) $@
	@$(ECHO) Creating $@
	@$(CP) $< $@
	@$(foreach h, $($*_HEADERS), \
	    echo "   $h_h.rst" >> $@;)

ifndef T_A
doxygen rtd sphinx: inc
	$(MAKE) -C O.$(EPICS_HOST_ARCH) $@
else

doxygen: Doxyfile
	@$(MKDIR) $(RTD_SRC)
	$(DOXYGEN)

rtd: doxygen $(API_RST_FILES) $(HEADER_MD_FILES)
	rsync -av $(INSTALL_DOC)/ $(RTD_SRC)/
	rsync -av $(HEADER_MD_FILES) $(RTD_SRC)/
	rsync -av $(API_RST_FILES) $(RTD_SRC)/
	rsync -av ../index.rst ../conf.py $(RTD_SRC)/

sphinx: rtd
	cd $(COMMON_DIR); $(PYTHON) -m sphinx rtd-src readthedocs
	rsync -av $(COMMON_DIR)/readthedocs $(INSTALL_HTML)/
endif

.PHONY: doxygen rtd sphinx

=== documentation/requirements.txt ===
sphinx==7.2.6
myst-parser==2.0.0
breathe==4.35.0
sphinx_copybutton==0.5.2
sphinx-hoverxref==1.3.0
sphinx-rtd-theme==2.0.0

=== src/tools/Makefile ===
#*************************************************************************
# Copyright (c) 2012 UChicago Argonne LLC, as Operator of Argonne
#     National Laboratory.
# EPICS BASE is distributed subject to a Software License Agreement found
# in file LICENSE that is included with this distribution.
#*************************************************************************

TOP = ../..
include $(TOP)/configure/CONFIG

# Bootstrap resolution: tools not installed yet
TOOLS = $(TOP)/src/tools

PERL_MODULES += EPICS/Copy.pm
PERL_MODULES += EPICS/Path.pm
PERL_MODULES += EPICS/Release.pm
PERL_MODULES += EPICS/Readfile.pm
PERL_MODULES += EPICS/Getopts.pm
PERL_MODULES += EPICS/PodHtml.pm
PERL_MODULES += EPICS/PodMD.pm
PERL_MODULES += EPICS/PodXHtml.pm
PERL_MODULES += Pod/Markdown.pm
PERL_MODULES += URI/Escape.pm

# This goes into lib/perl, not bin/<host>
PERL_MODULES += EpicsHostArch.pl

PERL_SCRIPTS += assembleSnippets.pl
PERL_SCRIPTS += convertRelease.pl
PERL_SCRIPTS += cvsclean.pl
PERL_SCRIPTS += depclean.pl
PERL_SCRIPTS += dos2unix.pl
PERL_SCRIPTS += epicsProve.pl
PERL_SCRIPTS += expandVars.pl
PERL_SCRIPTS += filterMakeflags.pl
PERL_SCRIPTS += fullPathName.pl
PERL_SCRIPTS += installEpics.pl
PERL_SCRIPTS += makeAPIheader.pl
PERL_SCRIPTS += makeMakefile.pl
PERL_SCRIPTS += makeTestfile.pl
PERL_SCRIPTS += mkmf.pl
PERL_SCRIPTS += munch.pl
PERL_SCRIPTS += podToMD.pl
PERL_SCRIPTS += podToHtml.pl
PERL_SCRIPTS += podRemove.pl
PERL_SCRIPTS += replaceVAR.pl
PERL_SCRIPTS += tap-to-junit-xml.pl
PERL_SCRIPTS += testFailures.pl
PERL_SCRIPTS += useManifestTool.pl
PERL_SCRIPTS += genVersionHeader.pl

PERL_SCRIPTS += makeRPath.py

HTMLS = style.css
HTMLS += EPICS/Getopts.html
HTMLS += EPICS/Path.html
HTMLS += EPICS/Readfile.html
HTMLS += fullPathName.html
HTMLS += makeAPIheader.html
HTMLS += munch.html
HTMLS += podToHtml.html
HTMLS += podToMD.html
HTMLS += podRemove.html

# The above Perl program documentation (modelled after Man pages)
# doesn't work well in Doxygen's "Related Pages" area, the titles
# for all doc's are "NAME", so don't convert these to Markdown.

include $(TOP)/configure/RULES

=== modules/libcom/src/Makefile ===
#*************************************************************************
# Copyright (c) 2010 UChicago Argonne LLC, as Operator of Argonne
#     National Laboratory.
# Copyright (c) 2002 The Regents of the University of California, as
#     Operator of Los Alamos National Laboratory.
# EPICS BASE is distributed subject to a Software License Agreement found
# in file LICENSE that is included with this distribution.
#*************************************************************************
LIBCOM := $(patsubst %/,%,$(dir $(lastword $(MAKEFILE_LIST))))
TOP = ../../..

include $(TOP)/configure/CONFIG

# Uncomment this to remove the (benign) valgrind helper stubs
#USR_CFLAGS += -DNVALGRIND

INC += valgrind/valgrind.h

EXPAND_COMMON = libComVersion.h@

EXPAND_ME += EPICS_LIBCOM_MAJOR_VERSION
EXPAND_ME += EPICS_LIBCOM_MINOR_VERSION
EXPAND_ME += EPICS_LIBCOM_MAINTENANCE_VERSION
EXPAND_ME += EPICS_LIBCOM_DEVELOPMENT_FLAG

INC += libComVersion.h

include $(LIBCOM)/as/Makefile
include $(LIBCOM)/bucketLib/Makefile
include $(LIBCOM)/calc/Makefile
include $(LIBCOM)/cvtFast/Makefile
include $(LIBCOM)/cppStd/Makefile
include $(LIBCOM)/cxxTemplates/Makefile
include $(LIBCOM)/dbmf/Makefile
include $(LIBCOM)/ellLib/Makefile
include $(LIBCOM)/env/Makefile
include $(LIBCOM)/error/Makefile
include $(LIBCOM)/fdmgr/Makefile
include $(LIBCOM)/flex/Makefile
include $(LIBCOM)/freeList/Makefile
include $(LIBCOM)/gpHash/Makefile
include $(LIBCOM)/iocsh/Makefile
include $(LIBCOM)/log/Makefile
include $(LIBCOM)/macLib/Makefile
include $(LIBCOM)/misc/Makefile
include $(LIBCOM)/osi/Makefile
include $(LIBCOM)/pool/Makefile
include $(LIBCOM)/ring/Makefile
include $(LIBCOM)/taskwd/Makefile
include $(LIBCOM)/timer/Makefile
include $(LIBCOM)/yacc/Makefile
include $(LIBCOM)/yajl/Makefile

# Generate library API header file
API_HEADER = libComAPI.h
Com_API = libCom
# Generate early to allow a sneak peak at dbChannel.h
API_HEADER += dbCoreAPI.h

# Library to build:
LIBRARY=Com

Com_SYS_LIBS_WIN32 = ws2_32 advapi32 user32 dbghelp

Com_RCS = Com.rc

ifeq ($(T_A),$(EPICS_HOST_ARCH))
  # Antelope & flex are needed to finish libCom
  DELAY_INSTALL_LIBS = YES
endif

# shared library ABI version.
SHRLIB_VERSION = $(EPICS_LIBCOM_MAJOR_VERSION).$(EPICS_LIBCOM_MINOR_VERSION).$(EPICS_LIBCOM_MAINTENANCE_VERSION)

include $(TOP)/configure/RULES

include $(LIBCOM)/as/RULES
include $(LIBCOM)/env/RULES
include $(LIBCOM)/error/RULES
include $(LIBCOM)/flex/RULES
include $(LIBCOM)/misc/RULES
include $(LIBCOM)/osi/RULES
include $(LIBCOM)/yajl/RULES

=== src/template/base/Makefile ===
# SPDX-FileCopyrightText: 1997 Argonne National Laboratory
#
# SPDX-License-Identifier: EPICS

TOP=../../..

include $(TOP)/configure/CONFIG

TEMPLATES_DIR = makeBaseApp

TEMPLATES += top/Makefile
TEMPLATES += top/.gitignore
TEMPLATES += top/configure/CONFIG
TEMPLATES += top/configure/CONFIG_SITE
TEMPLATES += top/configure/Makefile
TEMPLATES += top/configure/RELEASE
TEMPLATES += top/configure/RULES
TEMPLATES += top/configure/RULES.ioc
TEMPLATES += top/configure/RULES_DIRS
TEMPLATES += top/configure/RULES_TOP

SCRIPTS_HOST += makeBaseApp.pl

include $(TOP)/configure/RULES

=== src/template/ext/Makefile ===
# SPDX-FileCopyrightText: 2000 Argonne National Laboratory
#
# SPDX-License-Identifier: EPICS

TOP=../../..

include $(TOP)/configure/CONFIG

TEMPLATES_DIR = makeBaseExt

TEMPLATES += top/Makefile
TEMPLATES += top/.gitignore
TEMPLATES += top/README
TEMPLATES += top/configure/CONFIG
TEMPLATES += top/configure/CONFIG_SITE
TEMPLATES += top/configure/Makefile
TEMPLATES += top/configure/RELEASE
TEMPLATES += top/configure/RULES
TEMPLATES += top/configure/RULES_DIRS
TEMPLATES += top/configure/RULES_TOP
TEMPLATES += top/configure/RULES_IDL

TEMPLATES += $(subst ../,,$(wildcard ../top/configure/os/CONFIG*))

TEMPLATES += top/src/Makefile

TEMPLATES += top/exampleExt/Makefile
TEMPLATES += top/exampleExt/caExample.c
TEMPLATES += top/exampleExt/RELEASE_NOTES.HTM

TEMPLATES += top/simpleExt/Makefile

SCRIPTS_HOST += makeBaseExt.pl

include $(TOP)/configure/RULES

=== modules/ca/src/client/Makefile ===
#*************************************************************************
# Copyright (c) 2002 The University of Chicago, as Operator of Argonne
#     National Laboratory.
# Copyright (c) 2002 The Regents of the University of California, as
#     Operator of Los Alamos National Laboratory.
# EPICS BASE is distributed subject to a Software License Agreement found
# in file LICENSE that is included with this distribution.
#*************************************************************************
CURDIR := $(patsubst %/,%,$(dir $(lastword $(MAKEFILE_LIST))))
TOP = ../../../..

include $(TOP)/configure/CONFIG

HTMLS += CAref.html

#
#	includes to install from this subproject
#
INC += cadef.h
INC += caerr.h
INC += caeventmask.h
INC += caProto.h
INC += db_access.h
INC += addrList.h
INC += cacIO.h
INC += caDiagnostics.h
INC += net_convert.h
INC += caVersion.h

EXPAND_COMMON += caVersion.h@

EXPAND_ME += EPICS_CA_MAJOR_VERSION
EXPAND_ME += EPICS_CA_MINOR_VERSION
EXPAND_ME += EPICS_CA_MAINTENANCE_VERSION
EXPAND_ME += EPICS_CA_DEVELOPMENT_FLAG

LIBSRCS += cac.cpp
LIBSRCS += cacChannel.cpp
LIBSRCS += cacChannelNotify.cpp
LIBSRCS += cacContextNotify.cpp
LIBSRCS += cacReadNotify.cpp
LIBSRCS += cacWriteNotify.cpp
LIBSRCS += cacStateNotify.cpp
LIBSRCS += access.cpp
LIBSRCS += iocinf.cpp
LIBSRCS += convert.cpp
LIBSRCS += test_event.cpp
LIBSRCS += repeater.cpp
LIBSRCS += searchTimer.cpp
LIBSRCS += disconnectGovernorTimer.cpp
LIBSRCS += repeaterSubscribeTimer.cpp
LIBSRCS += baseNMIU.cpp
LIBSRCS += nciu.cpp
LIBSRCS += netiiu.cpp
LIBSRCS += udpiiu.cpp
LIBSRCS += tcpiiu.cpp
LIBSRCS += noopiiu.cpp
LIBSRCS += netReadNotifyIO.cpp
LIBSRCS += netWriteNotifyIO.cpp
LIBSRCS += netSubscription.cpp
LIBSRCS += tcpSendWatchdog.cpp
LIBSRCS += tcpRecvWatchdog.cpp
LIBSRCS += bhe.cpp
LIBSRCS += ca_client_context.cpp
LIBSRCS += oldChannelNotify.cpp
LIBSRCS += oldSubscription.cpp
LIBSRCS += getCallback.cpp
LIBSRCS += getCopy.cpp
LIBSRCS += putCallback.cpp
LIBSRCS += syncgrp.cpp
LIBSRCS += CASG.cpp
LIBSRCS += syncGroupNotify.cpp
LIBSRCS += syncGroupReadNotify.cpp
LIBSRCS += syncGroupWriteNotify.cpp
LIBSRCS += localHostName.cpp
LIBSRCS += comQueRecv.cpp
LIBSRCS += comQueSend.cpp
LIBSRCS += comBuf.cpp
LIBSRCS += hostNameCache.cpp
LIBSRCS += msgForMultiplyDefinedPV.cpp

API_HEADER = libCaAPI.h
ca_API = libCa

LIBRARY=ca

ca_RCS = ca.rc

ca_LIBS = Com

ca_SYS_LIBS_WIN32 = ws2_32 advapi32 user32

#   libs needed for PROD and TESTPRODUCT
PROD_LIBS = ca Com
# needed when its an object library build
PROD_SYS_LIBS_WIN32 = ws2_32 advapi32 user32

PROD_CMD += caRepeater catime acctst caConnTest casw caEventRate

OBJS_vxWorks = catime acctst caConnTest casw caEventRate acctstRegister

caRepeater_SRCS = caRepeater.cpp
catime_SRCS = catimeMain.c catime.c
acctst_SRCS = acctstMain.c acctst.c
caEventRate_SRCS = caEventRateMain.cpp caEventRate.cpp
casw_SRCS = casw.cpp
caConnTest_SRCS = caConnTestMain.cpp caConnTest.cpp

casw_SYS_LIBS_solaris = socket

SCRIPTS_HOST = S99caRepeater
SCRIPTS_Linux = caRepeater.service

EXPAND += S99caRepeater@
EXPAND += caRepeater.service@
EXPAND_VARS = INSTALL_BIN=$(FINAL_LOCATION)/bin/$(T_A)

SRC_DIRS += $(CURDIR)/test
PROD_HOST += ca_test
ca_test_SRCS = ca_test_main.c ca_test.c
ca_test_SYS_LIBS_WIN32 = ws2_32 advapi32 user32

OBJS_vxWorks += ca_test

# shared library ABI version.
SHRLIB_VERSION = $(EPICS_CA_MAJOR_VERSION).$(EPICS_CA_MINOR_VERSION).$(EPICS_CA_MAINTENANCE_VERSION)

include $(TOP)/configure/RULES

=== modules/ca/src/perl/Makefile ===
#*************************************************************************
# Copyright (c) 2008 UChicago Argonne LLC, as Operator of Argonne
#     National Laboratory.
# EPICS BASE is distributed subject to a Software License Agreement found
# in file LICENSE that is included with this distribution.
#*************************************************************************

TOP = ../../../..
include $(TOP)/configure/CONFIG

ifdef T_A
  PERL_VERSION = $(shell $(PERL) ../perlConfig.pl version)
  PERL_ARCHNAME = $(shell $(PERL) ../perlConfig.pl archname)
  PERL_ARCHPATH := $(PERL_VERSION)/$(PERL_ARCHNAME)

  PERL_ARCHLIB  := $(shell $(PERL) ../perlConfig.pl archlibexp)
  PERL_h = $(PERL_ARCHLIB)/CORE/perl.h

  EXTUTILS := $(shell $(PERL) ../perlConfig.pl privlibexp)/ExtUtils
  PERLBIN := $(shell $(PERL) ../perlConfig.pl binexp)
  XSUBPP := $(firstword $(wildcard $(PERLBIN)/xsubpp $(EXTUTILS)/xsubpp))

# Special settings for Darwin:
ifeq ($(OS_CLASS),Darwin)
  # Use hdepends command (not GNU compiler flags)
  # to generate header file dependancies for Darwin.
  # Darwin has multiple -arch compiler flags.
  HDEPENDS_METHOD = MKMF

  # Perl loadable libraries on Darwin have funny names
  LOADABLE_SHRLIB_PREFIX =
  LOADABLE_SHRLIB_SUFFIX = .$(shell $(PERL) ../perlConfig.pl dlext)

ifeq ($(wildcard $(PERL_h)),)
  # Perl's headers moved in Mojave
  SDK_PATH := $(shell xcodebuild -version -sdk macosx Path)
  PERL_ARCHLIB := $(SDK_PATH)/$(PERL_ARCHLIB)
endif
endif

ifneq ($(filter-out inc,$(strip $(MAKECMDGOALS))),)
ifeq ($(T_A),$(EPICS_HOST_ARCH))                 # No cross-builds (wrong Perl!)
ifeq ($(strip $(XSUBPP)),)
  $(warning Perl's xsubpp program was not found.)
  $(warning The Perl CA module will not be built.)
else
ifeq ($(wildcard $(PERL_h)),)
  $(warning Perl's C header files were not found.)
  $(warning The Perl CA module will not be built.)
else
ifeq ($(findstring $(OS_CLASS),WIN32 cygwin32),) # Doesn't build on WIN32
  LOADABLE_LIBRARY_HOST = Cap5

  PERL_SCRIPTS += capr.pl

  PERL_MODULES += CA.pm
  PERL_MODULES += $(PERL_ARCHPATH)/$(LOADABLE_SHRLIB_PREFIX)Cap5$(LOADABLE_SHRLIB_SUFFIX)

  HTMLS_DIR = .
  HTMLS = CA.html
endif
endif
endif
endif
endif
endif

Cap5_SRCS = Cap5.xs
Cap5_LIBS = ca Com
Cap5_INCLUDES = -I$(PERL_ARCHLIB)/CORE
Cap5_CFLAGS = $(shell $(PERL) ../perlConfig.pl ccflags)

CLEANS += Cap5.c

include $(TOP)/configure/RULES

ifdef T_A
  %.c: ../%.xs
	$(RM) $@ $@_new
	$(PERL) $(XSUBPP) -typemap $(EXTUTILS)/typemap $< > $@_new && $(MV) $@_new $@

  $(INSTALL_PERL_MODULES)/$(PERL_ARCHPATH)/%: %
	$(ECHO) "Installing loadable shared library $@"
	@$(INSTALL_LIBRARY) -d -m $(LIB_PERMISSIONS) $< $(INSTALL_PERL_MODULES)/$(PERL_ARCHPATH)
endif

=== modules/database/src/ioc/Makefile ===
#*************************************************************************
# Copyright (c) 2007 UChicago Argonne LLC, as Operator of Argonne
#     National Laboratory.
# Copyright (c) 2002 The Regents of the University of California, as
#     Operator of Los Alamos National Laboratory.
# EPICS BASE is distributed subject to a Software License Agreement found
# in file LICENSE that is included with this distribution.
#*************************************************************************
IOCDIR := $(patsubst %/,%,$(dir $(lastword $(MAKEFILE_LIST))))
TOP = ../../../..

include $(TOP)/configure/CONFIG

USR_CPPFLAGS += -DUSE_TYPED_RSET -DUSE_TYPED_DSET

# Shared library ABI version.
SHRLIB_VERSION = $(EPICS_DATABASE_MAJOR_VERSION).$(EPICS_DATABASE_MINOR_VERSION).$(EPICS_DATABASE_MAINTENANCE_VERSION)

# dbCoreAPI.h generated earlier during libcom/
dbCore_API = dbCore

LIBRARY_IOC += dbCore
dbCore_LIBS += ca Com
dbCore_SYS_LIBS_WIN32 += ws2_32

dbCore_RCS += dbCore.rc

EXPAND_COMMON += databaseVersion.h@

EXPAND_ME += EPICS_DATABASE_MAJOR_VERSION
EXPAND_ME += EPICS_DATABASE_MINOR_VERSION
EXPAND_ME += EPICS_DATABASE_MAINTENANCE_VERSION
EXPAND_ME += EPICS_DATABASE_DEVELOPMENT_FLAG

INC += databaseVersion.h

PROD_LIBS = Com

include $(IOCDIR)/as/Makefile
include $(IOCDIR)/bpt/Makefile
include $(IOCDIR)/db/Makefile
include $(IOCDIR)/dbStatic/Makefile
include $(IOCDIR)/dbtemplate/Makefile
include $(IOCDIR)/misc/Makefile
include $(IOCDIR)/registry/Makefile
include $(IOCDIR)/rsrv/Makefile

GENVERSION = epicsVCS.h
GENVERSIONMACRO = EPICS_VCS_VERSION

include $(TOP)/configure/RULES

include $(IOCDIR)/dbStatic/RULES
include $(IOCDIR)/bpt/RULES
include $(IOCDIR)/db/RULES
include $(IOCDIR)/dbtemplate/RULES

epicsRelease$(DEP): $(COMMON_DIR)/$(GENVERSION)

=== modules/database/src/std/Makefile ===
#*************************************************************************
# Copyright (c) 2011 UChicago Argonne LLC, as Operator of Argonne
#     National Laboratory.
# Copyright (c) 2002 The Regents of the University of California, as
#     Operator of Los Alamos National Laboratory.
# EPICS BASE is distributed subject to a Software License Agreement found
# in file LICENSE that is included with this distribution.
#*************************************************************************
STDDIR := $(patsubst %/,%,$(dir $(lastword $(MAKEFILE_LIST))))
TOP = ../../../..

include $(TOP)/configure/CONFIG

USR_CPPFLAGS += -DUSE_TYPED_RSET -DUSE_TYPED_DSET

# Shared library ABI version.
SHRLIB_VERSION = $(EPICS_DATABASE_MAJOR_VERSION).$(EPICS_DATABASE_MINOR_VERSION).$(EPICS_DATABASE_MAINTENANCE_VERSION)

API_HEADER = dbRecStdAPI.h
dbRecStd_API = dbRecStd

LIBRARY_IOC += dbRecStd
dbRecStd_LIBS = dbCore ca Com

dbRecStd_RCS += dbRecStd.rc

include $(STDDIR)/rec/Makefile
include $(STDDIR)/dev/Makefile
include $(STDDIR)/filters/Makefile
include $(STDDIR)/link/Makefile
include $(STDDIR)/softIoc/Makefile

DOCS += ComponentReference.md
HTMLS += ComponentReference.html

include $(TOP)/configure/RULES

include $(STDDIR)/rec/RULES
include $(STDDIR)/softIoc/RULES

=== modules/database/src/tools/Makefile ===
#*************************************************************************
# Copyright (c) 2018 UChicago Argonne LLC, as Operator of Argonne
#     National Laboratory.
# EPICS BASE is distributed subject to a Software License Agreement found
# in file LICENSE that is included with this distribution.
#*************************************************************************
TOP=../../../..

include $(TOP)/configure/CONFIG

PERL_MODULES += DBD.pm
PERL_MODULES += DBD/Base.pm
PERL_MODULES += DBD/Breaktable.pm
PERL_MODULES += DBD/Device.pm
PERL_MODULES += DBD/Driver.pm
PERL_MODULES += DBD/Link.pm
PERL_MODULES += DBD/Function.pm
PERL_MODULES += DBD/Menu.pm
PERL_MODULES += DBD/Output.pm
PERL_MODULES += DBD/Parser.pm
PERL_MODULES += DBD/Recfield.pm
PERL_MODULES += DBD/Recordtype.pm
PERL_MODULES += DBD/Record.pm
PERL_MODULES += DBD/Registrar.pm
PERL_MODULES += DBD/Variable.pm

PERL_MODULES += EPICS/IOC.pm
HTMLS += EPICS/IOC.html

PERL_SCRIPTS += makeIncludeDbd.pl

PERL_SCRIPTS += dbdToMenuH.pl
PERL_SCRIPTS += dbdToRecordtypeH.pl
PERL_SCRIPTS += dbdExpand.pl
PERL_SCRIPTS += dbExpand.pl
PERL_SCRIPTS += dbdToHtml.pl
PERL_SCRIPTS += dbdToMD.pl
PERL_SCRIPTS += registerRecordDeviceDriver.pl

HTMLS += dbdToHtml.html

# Build Package Config Files

C_CFLAGS += $(filter-out -g,$(filter-out -O%,$(filter-out -W%,$(CPPFLAGS))))
C_CFLAGS += $(filter-out -g,$(filter-out -O%,$(filter-out -W%,$(CFLAGS))))
PKGVARS += FINAL_LOCATION OS_CLASS CMPLR_CLASS C_CFLAGS LDFLAGS LDLIBS
PKGVARS += EPICS_VERSION EPICS_REVISION EPICS_MODIFICATION EPICS_PATCH_LEVEL
PKGVARS += CC CCC CPP AR LD
PKGVARS += EPICS_BASE_HOST_LIBS EPICS_BASE_IOC_LIBS

EXPANDFLAGS += $(foreach var,$(PKGVARS),-D$(var)="$(strip $($(var)))")
PKGCONFIG += epics-base-$(T_A).pc
ifeq ($(T_A),$(EPICS_HOST_ARCH))
PKGCONFIG += epics-base.pc
endif

EXPAND += $(PKGCONFIG:%=%@)
CLEANS += epics-base-$(T_A).pc@

include $(TOP)/configure/RULES

epics-base-$(T_A).pc@: ../epics-base-arch.pc@
	@$(RM) $@
	@$(CP) $< $@

=== modules/libcom/src/as/Makefile ===
#*************************************************************************
# Copyright (c) 2010 Brookhaven Science Associates, as Operator of
#     Brookhaven National Lab.
# Copyright (c) 2011 UChicago Argonne LLC, as Operator of Argonne
#     National Laboratory.
# Copyright (c) 2002 The Regents of the University of California, as
#     Operator of Los Alamos National Laboratory.
# EPICS BASE is distributed subject to a Software License Agreement found
# in file LICENSE that is included with this distribution. 
#************************************************************************

# This is a Makefile fragment, see src/libCom/Makefile.

SRC_DIRS += $(LIBCOM)/as

INC += asLib.h
INC += asTrapWrite.h

Com_SRCS += asLib.c
Com_SRCS += asTrapWrite.c

# Allow early access to dbChannel.h
asTrapWrite_CPPFLAGS = -I$(LIBCOM)/../../database/src/ioc/db


CLEANS += asLib.c asLib_lex.c

=== debian/changelog ===
epics-base (7.0.9-1) unstable; urgency=medium

  * Packaging 7.0.9

 --  <jhanks@caltech.edu>  Tue, 12 Aug 2025 17:30:09 -0700

epics-base (3.15.9-1) unstable; urgency=medium

  * Updating to 3.15.9

 -- Jonathan Hanks <jhanks@caltech.edu>  Tue, 13 Jun 2023 22:15:53 +0000

epics-base (3.15.5-4) bullseye; urgency=medium

  * change install location for libCap5.so 

 -- Erik von Reis <evonreis@caltech.edu>  Wed, 14 Sep 2022 23:35:22 -0700

epics-base (3.15.5-3) unstable; urgency=medium

  * rebuild package.

 -- Erik von Reis <evonreis@caltech.edu>  Thu, 01 Sep 2022 16:35:49 -0700

epics-base (3.15.5-2ligo1) unstable; urgency=medium

  * Branch master to ligo-3.15.5-2 and reapply LIGO PV name length patch

 -- Ryan Blair <ryan.blair@ligo.org>  Fri, 14 Dec 2018 09:42:28 -0800

epics-base (3.15.5-2) unstable; urgency=medium

  * ioclogserver package needs to depend on lsb-base

 -- Martin Konrad <konrad@frib.msu.edu>  Wed, 03 Oct 2018 18:48:23 -0400

epics-base (3.15.5-1) unstable; urgency=medium

  * New upstream version 3.15.5
  * Rebase patch queue
  * Update control file for 3.15.5
  * Adjust hard-coded version numbers

 -- Martin Konrad <konrad@frib.msu.edu>  Mon, 10 Sep 2018 10:16:26 -0400

epics-base (3.15.3-13) unstable; urgency=medium

  [ Michael Davidsaver ]
  * update for debian 9
  * update build deps
  * update mingw toolchain name
  * patch: disable epicsExceptionTest

 -- Michael Davidsaver <mdavidsaver@gmail.com>  Wed, 19 Jul 2017 15:46:36 +0200

epics-base (3.15.3-12) unstable; urgency=medium

  * update patch set
      Backport
        bswap16/32 as functions
        Applied Till's fix for lp:1581212
        ca: Fix client bug (race condition) in ipAddrToAsciiEngine
        Fix lsi/lso puts with DBF_STRING data

 -- Michael Davidsaver <mdavidsaver@gmail.com>  Thu, 11 Aug 2016 18:31:34 -0400

epics-base (3.15.3-11) unstable; urgency=medium

  [ Martin Konrad ]
  * Install ascheck into folder /usr/bin

 -- Martin Konrad <konrad@frib.msu.edu>  Thu, 14 Jul 2016 13:36:53 -0400

epics-base (3.15.3-10) unstable; urgency=medium

  * Update deps to fix upgrades after epics-msi removal

 -- Michael Davidsaver <mdavidsaver@gmail.com>  Mon, 16 May 2016 14:26:21 -0400

epics-base (3.15.3-9) unstable; urgency=medium

  * Bump version once more to avoid ioclogserver conflicts

 -- Michael Davidsaver <mdavidsaver@gmail.com>  Wed, 27 Apr 2016 18:52:26 -0400

epics-base (3.15.3-8) unstable; urgency=medium

  * Fold epics-msi into epics-dev
    Avoid broken symlink in epics-dev when epics-msi was not installed.
  * Move iocLogServer executable to epics-dev.  ioclogserver now
    has only the init script.
  * fixup copyright

 -- Michael Davidsaver <mdavidsaver@gmail.com>  Mon, 25 Apr 2016 09:15:04 -0400

epics-base (3.15.3-7) unstable; urgency=medium

  * epics-perl: Fix install location for CA.pm

 -- Michael Davidsaver <mdavidsaver@gmail.com>  Fri, 22 Apr 2016 14:37:58 -0400

epics-base (3.15.3-6) unstable; urgency=medium

  * Add patch that fixes memory corruption of C++ epicsThread API
  * Add patch that fixes a crash when initializing string records
  * Add patch fixing lp:1539791
  * Add patch to fix RTEMS NTP sync. bug
  * Fix gen-harden.sh to append to TARGET_*FLAGS instead of
    overwriting.

 -- Martin Konrad <konrad@frib.msu.edu>  Mon, 11 Apr 2016 08:54:16 -0400

epics-base (3.15.3-4) unstable; urgency=medium

  * Only -D and -I in pkg-config files
    The hardening flags were leaking in
  * Redo debian/copyright in machine parsable format
  * Add missing adduser dep to ioclogserver

 -- Michael Davidsaver <mdavidsaver@gmail.com>  Thu, 10 Mar 2016 16:18:05 -0500

epics-base (3.15.3-3) unstable; urgency=medium

  * Adapt to change coming in epics-debhelper 8.14.
    skip dh_epics_postinstall

 -- Michael Davidsaver <mdavidsaver@gmail.com>  Wed, 09 Mar 2016 20:30:57 -0500

epics-base (3.15.3-2) unstable; urgency=medium

  * Add /etc/epics/configure/conf.d/05hardening.make
    so that downstream builds for Linux targets use hardening
    flags by default.
    Can be overridden by defining 'SKIP_HARDENING=YES'

 -- Michael Davidsaver <mdavidsaver@gmail.com>  Wed, 20 Jan 2016 11:10:55 -0500

epics-base (3.15.3-1) unstable; urgency=medium

  * Imported Upstream version 3.15.3
  * Rebase patch queue from v3.14.12.3
  * Update control file for v3.15.3
  * Adjust hard-coded version numbers
  * Fix mingw32 cross-build
  * Do not install some libraries that have been removed with 3.15
  * Do not build package epics-compat-dev anymore
  * Fix broken install rule for PCAS headers
  * Add some new files to the epics-dev package
  * Base 3.15 does not install CA tools for *-debug arch anymore
  * Install pkg-config files into system-wide folder
  * Use epics-debhelper >=8.12 to disable rpath
  * Bump up standards-version to 3.9.6
  * Add patch for binding to a specific interface
  * Fix ambiguous epics-dev dependency
  * Update README.Debian

 -- Martin Konrad <konrad@frib.msu.edu>  Tue, 05 Jan 2016 10:28:36 -0800

epics-base (3.14.12.3-10) unstable; urgency=low

  * Fix mingw build failure

 -- Michael Davidsaver <mdavidsaver@bnl.gov>  Fri, 01 May 2015 14:56:07 -0400

epics-base (3.14.12.3-9) unstable; urgency=low

  * fix ioclogserver.postinst (Richard Fearn)
  * Backports from 3.14.12.5
    dev, rec: Fix smoothing for NaN/+inf/-inf values
    Reject NULL callback functions in ca_array_*_callback
    catools: better out-of-bounds handling when printing enums
    Fix buffer overflow in epicsStrnRawFromEscaped (lp:1388313)
    Fix FLNK-over-CA error message
    gdd fix issue when copying from an empty array
    catools: make `caget -lb` output '0' instead of empty string
    Back-ported the tapfiles build target from 3.15 (makefile only)
    tool_lib.c: ensure output string is always set
    dbReadTest.c: flush errlog on exit as per lp:1419879
    don't destroy locked mutex
    Fix dbVerify()'s postfix buffer size
    db: Allow link fields to return a DOUBLE value


=== debian/control ===
Source: epics-base
Section: devel
Priority: extra
Maintainer: Martin Konrad <konrad@frib.msu.edu>
Uploaders: Michael Davidsaver <mdavidsaver@gmail.com>,
           Ralph Lange <Ralph.Lange@gmx.de>
Build-Depends: debhelper (>= 9), epics-debhelper (>= 8.12~),
               libreadline6-dev | libreadline-dev, libncurses5-dev, perl
Standards-Version: 3.9.6
Vcs-Git: https://github.com/epicsdeb/epics-base.git
Vcs-Browser: https://github.com/epicsdeb/epics-base
Homepage: http://www.aps.anl.gov/epics/

Package: libepics7.0.9
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: epics-catools
Conflicts: epics-perl (<= 3.14.10-7)
Description: EPICS Base libraries for clients and servers
 The Experimental Physics and Industrial Control System is a collection of
 tools, libraries and applications for creating a distributed soft real-time
 control systems.
 .
 This package contains host system shared libraries for clients and IOCs.

Package: libepics7.0.9-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: libepics7.0.9 (= ${binary:Version}), ${misc:Depends},
Provides: libepics-dbg
Description: Files needed to develop new EPICS applications
 The Experimental Physics and Industrial Control System is a collection of
 tools, libraries and applications for creating a distributed soft real-time
 control systems.
 .
 Debug symbols for EPICS shared libraries and utilities.

Package: ioclogserver
Section: admin
Architecture: any
Depends: libepics7.0.9 (= ${binary:Version}),
         epics-dev (= ${binary:Version}), lsb-base,
         ${misc:Depends}, ${shlibs:Depends}, adduser,
Description: Log recording daemon for EPICS IOCS
 The Experimental Physics and Industrial Control System is a collection of
 tools, libraries and applications for creating a distributed soft real-time
 control systems.
 .
 The IOC log server listens for network log messages sent from
 IOC.  This is used by the caputlog support module to collect
 messages relating to PV value changes.

Package: epics-dev
Architecture: any
Depends: libepics7.0.9 (= ${binary:Version}), epics-catools (= ${binary:Version}),
         perl (>= 5.10.0~),
         libreadline6-dev,
        ${shlibs:Depends}, ${misc:Depends}
Suggests: epics-doc        (= ${binary:Version}),
          epics-perl       (= ${binary:Version}),
          epics-pcas-dev   (= ${binary:Version}),
          ioclogserver     (= ${binary:Version}),
Conflicts: epics-catools   (<= 3.14.11-6),
           epics-perl      (<= 3.14.12.3-1),
           ioclogserver    (<< 3.15.3-9),
Replaces:  epics-msi (<< 3.15.3-8~),
Breaks:    epics-msi (<< 3.15.3-8~),
Description: Files needed to develop new EPICS applications
 The Experimental Physics and Industrial Control System is a collection of
 tools, libraries and applications for creating a distributed soft real-time
 control systems.
 .
 Libraries, headers, and utilities needed to develop applications
 targeted to the host system.

Package: epics-msi
Architecture: all
Depends: ${misc:Depends}
Description: EPICS Macro Substitution and Include tool
 MSI is a general purpose macro substitution/include tool.
 It accepts as input an ascii template file.
 .
 This is a dummy package which can be removed.

Package: epics-catools
Section: admin
Architecture: any
Depends: libepics7.0.9 (= ${binary:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: Command line utilities for EPICS
 The Experimental Physics and Industrial Control System is a collection of
 tools, libraries and applications for creating a distributed soft real-time
 control systems.
 .
 EPICS utilities such as caget and caput as well as the caRepeater daemon.

Package: epics-perl
Architecture: any
Depends: libepics7.0.9 (= ${binary:Version}),
         ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}
Conflicts: epics-libs (<= 3.14.10-7),  epics-dev (<= 3.14.12.3-2),
Description: Perl bindings for EPICS
 The Experimental Physics and Industrial Control System is a collection of
 tools, libraries and applications for creating a distributed soft real-time
 control systems.
 .
 Perl bindings for EPICS

Package: epics-doc
Architecture: all
Depends: ${misc:Depends}
Section: doc
Replaces:  epics-msi (<< 3.15.3-8~),
Breaks:    epics-msi (<< 3.15.3-8~),
Description: EPICS documentation
 The Experimental Physics and Industrial Control System is a collection of
 tools, libraries and applications for creating a distributed soft real-time
 control systems.
 .
 Documentation for EPICS Base

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
BMAKEFLAGS += -j$(NUMJOBS)
endif

ifeq "$(DEB_BUILD_ARCH)" "i386"
EPICS_HOST_ARCH:=linux-x86
else ifeq "$(DEB_BUILD_ARCH)" "amd64"
EPICS_HOST_ARCH:=linux-x86_64
else
EPICS_HOST_ARCH:=$(shell ./startup/EpicsHostArch)
endif
export EPICS_HOST_ARCH

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Link only --as-needed
# EPICS uses -O3, let's not lower the standards
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export DEB_CFLAGS_STRIP = -g -O2
export DEB_CXXFLAGS_STRIP = -g -O2

# chop out the source version from Changelog (ie 3.14.12)
# Taken from CDBS
DEB_VERSION = $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION = $(shell echo $(DEB_VERSION) | cut -d: -f2-)
SOV=$(shell echo "$(DEB_NOEPOCH_VERSION)"| cut -f '1' -d '-')
DEBV=$(shell echo "$(DEB_NOEPOCH_VERSION)"| cut -f '2-' -d '-')

# fetch the list of all binary packages being built
ALLBINS := $(shell dh_listpackages)

TARGETS = $(EPICS_HOST_ARCH)-debug

#ifneq (,$(findstring epics-win32,$(ALLBINS)))
#TARGETS += win32-x86-mingw
#endif

export CROSS_COMPILER_TARGET_ARCHS=$(TARGETS)

export SHRLIB_VERSION=$(SOV)

%:
	ls modules/RE* || true
	dh $@ --with epics -Sepicsmake --parallel
	ls modules/RE* || true

override_dh_auto_clean:
	ls modules/RE* || true
	dh_auto_clean
	rm -rf configure/conf.d
	rm -f modules/RE* || true

override_dh_auto_build:
	install -d configure/conf.d
	./debian/gen-harden.sh > configure/conf.d/05hardening.make
	dh_auto_build -- FINAL_LOCATION=/usr/lib/epics EPICS_SITE_VERSION=$(DEBV)
	sed -i -e "s|\$$ENV{EPICS_HOST_ARCH}|$(EPICS_HOST_ARCH)|g" bin/*/makeBaseApp.pl

override_dh_auto_install:
	dh_auto_install -- FINAL_LOCATION=/usr/lib/epics EPICS_SITE_VERSION=$(DEBV)

# skip this since we should install configure/RELEASE
override_dh_epics_postinstall:
	# no op

override_dh_auto_test: # skip for development

USRBINS=makeBaseApp.pl makeBaseExt.pl softIoc caget caput camonitor cainfo caRepeater casw msi iocLogServer ascheck

PERLBINS=caget.pl caput.pl camonitor.pl cainfo.pl capr.pl

# /usr/share/perl5
PERLLIB=$(shell perl -MConfig -e 'print $$Config{vendorlib}')
# /usr/lib/x86_64-linux-gnu/perl5/5.20  (deb8)
# /usr/lib/perl5 (deb7)
PERLARCH=$(shell perl -MConfig -e 'print $$Config{vendorarch}')

override_dh_install:
	sed -i -e "s|^.*EPICS_SITE_VERSION.*$$|EPICS_SITE_VERSION = $(DEBV)|" debian/tmp/usr/lib/epics/configure/CONFIG_SITE

	# some object code is getting installed somehow
	rm -f debian/tmp/usr/lib/epics/bin/linux-*/*.o

	# relocate configure/
	# copy to /etc/epics/configure and /usr/share/epics-dev/configure

	install -d debian/tmp/etc/epics
	install -d debian/tmp/usr/share/epics-dev
	# make sure the clang compiler specific headers get included
	# this is to help with clang based tooling and interop
	install -d debian/tmp/usr/lib/epics/include/compiler/clang
	cp -dR modules/libcom/src/osi/compiler/clang debian/tmp/usr/lib/epics/include/compiler/

	cp -dR debian/tmp/usr/lib/epics/configure debian/tmp/etc/epics/
	mv debian/tmp/usr/lib/epics/configure debian/tmp/usr/share/epics-dev/configure

	install -d debian/tmp/usr/lib/epics/configure

	# populated /usr/lib/epics/configure with symlinks to /etc/epics/configure
	# except for conf.d and rules.d
	for ff in debian/tmp/etc/epics/configure/*; do \
		ln -s /etc/epics/configure/`basename $$ff` debian/tmp/usr/lib/epics/configure/`basename $$ff`; \
	done

	install -d debian/tmp/etc/epics/configure/conf.d
	cp configure/conf.d/05hardening.make debian/tmp/etc/epics/configure/conf.d/
	echo "ALL_CROSS_COMPILER_TARGET_ARCHS += $(TARGETS)" > debian/tmp/etc/epics/configure/conf.d/01debug.make

	install -d debian/tmp/usr/bin

	# install executable to /usr/bin
	for B in $(USRBINS); do mv debian/tmp/usr/lib/epics/bin/$(EPICS_HOST_ARCH)/$$B debian/tmp/usr/bin/$$B; done
	# remove extension from perl scripts
	for P in debian/tmp/usr/bin/*.pl; do mv $$P $${P%.pl};done
	# leave sym-links to /usr/bin in /usr/lib/epics/bin/$EPICS_HOST_ARCH
	for B in debian/tmp/usr/bin/*; \
		do ln -s ../../../../bin/`basename $$B` debian/tmp/usr/lib/epics/bin/$(EPICS_HOST_ARCH)/`basename $$B`; \
	done

	install -d debian/epics-dev/$(PERLLIB)
	install -d debian/epics-perl/$(PERLARCH)/auto
	install -d debian/epics-perl/$(PERLARCH)/auto/Cap5

	# install EPICS::* modules under /$(PERLLIB)/
	mv debian/tmp/usr/lib/epics/lib/perl/EPICS debian/epics-dev/$(PERLLIB)/

	# Relocate CA to /usr/lib/perl5/
	mv debian/tmp/usr/lib/epics/lib/perl/CA.pm debian/epics-perl/$(PERLARCH)/
	# libCap5.so to /usr/lib/perl5/auto/
	mv debian/tmp/usr/lib/epics/lib/perl/5.*/*/libCap5.so debian/epics-perl/$(PERLARCH)/auto/Cap5/Cap5.so

	# Don't need other copies
	rm debian/tmp/usr/lib/epics/lib/linux-*/libCap5.so

	# This path is used by CA.pm
	ln -s ${EPICS_HOST_ARCH} debian/tmp/usr/lib/epics/lib/host

	dh_install --fail-missing

	install -d debian/epics-perl/usr/lib/epics/bin/$(EPICS_HOST_ARCH)
	install -d debian/epics-perl/usr/lib/epics/bin/$(EPICS_HOST_ARCH)-debug

	for arch in $(EPICS_HOST_ARCH); do for name in $(PERLBINS); do \
	  mv debian/epics-dev/usr/lib/epics/bin/$$arch/$$name debian/epics-perl/usr/lib/epics/bin/$$arch/ \
	;done ;done

ifneq (,$(findstring epics-win32,$(ALLBINS)))
	install -d debian/epics-win32/usr/lib/epics/include/os
	mv debian/epics-dev/usr/lib/epics/include/os/WIN32 debian/epics-win32/usr/lib/epics/include/os/
endif

	chmod -x debian/epics-dev/usr/lib/epics/configure/Sample.Makefile

override_dh_installdocs:
	dh_installdocs -A README

override_dh_strip_rtems:
	dh_strip_rtems --dbg-package=libepics$(SOV)-dbg

override_dh_makeshlibs:
	dh_makeshlibs -Nepics-dev -a
	# prevent the .so symlinks under usr/lib/epics/lib from being detected.
	dh_makeshlibs -pepics-dev -Xusr/lib/epics

override_dh_shlibdeps:
	dh_shlibdeps -Nlibepics$(SOV) -a
	# Prevent self dependency
	#  This would happen because the package provides several dependent libraries
	dh_shlibdeps -plibepics$(SOV) -- -xlibepics$(SOV)

# We provide our own deps
override_dh_epicsdep:

# Failure to start does not halt package install
override_dh_installinit:
	dh_installinit --error-handler=true
